#!/usr/bin/env python




##################################################
## DEPENDENCIES
import sys
import os
import os.path
try:
    import builtins as builtin
except ImportError:
    import __builtin__ as builtin
from os.path import getmtime, exists
import time
import types
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import *
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers
from Cheetah.compat import unicode
from json import dumps
from six.moves.urllib.parse import quote
from Plugins.Extensions.OpenWebif.controllers.i18n import tstrings
from Plugins.Extensions.OpenWebif.vtiaddon import showPicons, showPiconBackground

##################################################
## MODULE CONSTANTS
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '3.2.5'
__CHEETAH_versionTuple__ = (3, 2, 5, 'final', 0)
__CHEETAH_genTime__ = 1624886282.8231175
__CHEETAH_genTimestamp__ = 'Mon Jun 28 13:18:02 2021'
__CHEETAH_src__ = '/home/oe1/atv65mipsel/build-enviroment/builds/openatv/release/dm520/tmp/work/mips32el-oe-linux/enigma2-plugin-extensions-openwebif/1.4.6+gitAUTOINC+f91a80517e-r0/git/plugin/controllers/views/responsive/ajax/event.tmpl'
__CHEETAH_srcLastModified__ = 'Mon Jun 28 13:17:41 2021'
__CHEETAH_docstring__ = 'Autogenerated by Cheetah: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class event(Template):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        super(event, self).__init__(*args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def respond(self, trans=None):



        ## CHEETAH: main method generated for this template
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''
''')
        etime = time.localtime(VFFSL(SL,"event.begin",True))
        channel = VFN(VFFSL(SL,"event.channel",True),"replace",False)("'", r"\'")
        title = VFN(VFFSL(SL,"event.title",True),"replace",False)("'", r"\'")
        sref = quote(VFFSL(SL,"event.sref",True), safe=' ~@#$&()*!+=:;,.?/\'')
        endTime = VFFSL(SL,"int",False)(VFFSL(SL,"event.begin",True) + VFFSL(SL,"event.duration",True))
        metadata = VFFSL(SL,"dumps",False)({ 'sref': quote(VFFSL(SL,"event.sref",True)), 'id': VFFSL(SL,"event.id",True), 'begin': VFFSL(SL,"event.begin",True), 'end': VFFSL(SL,"int",False)(VFFSL(SL,"event.begin",True) + VFFSL(SL,"event.duration",True)) }, indent=None, separators=(",", ":"))
        write('''
''')
        piconCssClass = ''
        if VFFSL(SL,"showPiconBackground",True): # generated from line 14, col 1
            piconCssClass = 'picon--with-background'
        write("""
<div data-metadata='""")
        _v = VFFSL(SL,"metadata",True) # '$metadata' on line 18, col 21
        if _v is not None: write(_filter(_v, rawExpr='$metadata')) # from line 18, col 21.
        write('''\'>
<div class="row clearfix pull-right">
\t<div class="col-xs-12">

''')
        if VFFSL(SL,"showPicons",True) and 'picon' in VFFSL(SL,"event",True): # generated from line 22, col 1
            piconHTML = '<img class="img-fluid" src="%s" alt="Channel logo">' % VFFSL(SL,"event.picon",True)
            write('''\t\t<div class="event-detail__picon ''')
            _v = VFFSL(SL,"piconCssClass",True) # '$piconCssClass' on line 24, col 35
            if _v is not None: write(_filter(_v, rawExpr='$piconCssClass')) # from line 24, col 35.
            write('''" style="margin: 0 auto;">
\t\t\t<a href="javascript:zapChannel(\'''')
            _v = VFFSL(SL,"sref",True) # '$sref' on line 25, col 36
            if _v is not None: write(_filter(_v, rawExpr='$sref')) # from line 25, col 36.
            write("""', '""")
            _v = VFFSL(SL,"channel",True) # '$channel' on line 25, col 45
            if _v is not None: write(_filter(_v, rawExpr='$channel')) # from line 25, col 45.
            write('''\');" title="''')
            _v = VFFSL(SL,"tstrings",True)['zap_to'] # "$tstrings['zap_to']" on line 25, col 65
            if _v is not None: write(_filter(_v, rawExpr="$tstrings['zap_to']")) # from line 25, col 65.
            write(''' ''')
            _v = VFFSL(SL,"channel",True) # '$channel' on line 25, col 85
            if _v is not None: write(_filter(_v, rawExpr='$channel')) # from line 25, col 85.
            write('''">''')
            _v = VFFSL(SL,"piconHTML",True) # '$piconHTML' on line 25, col 95
            if _v is not None: write(_filter(_v, rawExpr='$piconHTML')) # from line 25, col 95.
            write('''</a>
\t\t</div>
''')
        else: # generated from line 27, col 1
            write('''\t\t<h4>''')
            _v = VFFSL(SL,"channel",True) # '$channel' on line 28, col 7
            if _v is not None: write(_filter(_v, rawExpr='$channel')) # from line 28, col 7.
            write('''</h4>
''')
        write('''
\t\t<div class="event-detail__actions m-b-10">
''')
        #  #if $isProtected
        #  		<span class="link--not-skinned" target="_blank" title="$tstrings['locked']"><i class="material-icons material-icons-centered">lock_outline</i></span>
        #  #else
        if VFFSL(SL,"type",True) == "radio": # generated from line 35, col 3
            write('''\t\t\t<!-- button type="button" onclick="addTimer(\'\', \'''')
            _v = VFFSL(SL,"sref",True) # '$sref' on line 36, col 53
            if _v is not None: write(_filter(_v, rawExpr='$sref')) # from line 36, col 53.
            write("""', '""")
            _v = VFFSL(SL,"channel",True) # '$channel' on line 36, col 62
            if _v is not None: write(_filter(_v, rawExpr='$channel')) # from line 36, col 62.
            write('''\', \'\');" class="link--not-skinned" title="''')
            _v = VFFSL(SL,"tstrings",True)['add_timer'] # "$tstrings['add_timer']" on line 36, col 112
            if _v is not None: write(_filter(_v, rawExpr="$tstrings['add_timer']")) # from line 36, col 112.
            write('''"><i class="icon material-icons material-icons-centered">alarm_add</i></button -->
''')
        write('''
\t\t\t<button type="button" onclick="zapChannel(\'''')
        _v = VFFSL(SL,"sref",True) # '$sref' on line 39, col 47
        if _v is not None: write(_filter(_v, rawExpr='$sref')) # from line 39, col 47.
        write("""', '""")
        _v = VFFSL(SL,"channel",True) # '$channel' on line 39, col 56
        if _v is not None: write(_filter(_v, rawExpr='$channel')) # from line 39, col 56.
        write('''\');" class="link--not-skinned" title="''')
        _v = VFFSL(SL,"tstrings",True)['zap_to'] # "$tstrings['zap_to']" on line 39, col 102
        if _v is not None: write(_filter(_v, rawExpr="$tstrings['zap_to']")) # from line 39, col 102.
        write(''' ''')
        _v = VFFSL(SL,"channel",True) # '$channel' on line 39, col 122
        if _v is not None: write(_filter(_v, rawExpr='$channel')) # from line 39, col 122.
        write('''"><i class="icon material-icons material-icons-centered">settings_remote</i></button>

''')
        if VFFSL(SL,"event.link",True) != "": # generated from line 41, col 3
            write('''\t\t\t<a href="''')
            _v = VFFSL(SL,"event.link",True) # '$event.link' on line 42, col 13
            if _v is not None: write(_filter(_v, rawExpr='$event.link')) # from line 42, col 13.
            write('''" class="now-next__external-link link--not-skinned" target="extlink" title="''')
            _v = VFFSL(SL,"tstrings",True)['open_in_new_window'] # "$tstrings['open_in_new_window']" on line 42, col 100
            if _v is not None: write(_filter(_v, rawExpr="$tstrings['open_in_new_window']")) # from line 42, col 100.
            write('''"><i class="material-icons material-icons-centered">phonelink</i></a>
''')
        else: # generated from line 43, col 3
            write('''\t\t\t<button type="button" onclick="open_epg_dialog(\'''')
            _v = VFFSL(SL,"sref",True) # '$sref' on line 44, col 52
            if _v is not None: write(_filter(_v, rawExpr='$sref')) # from line 44, col 52.
            write("""', '""")
            _v = VFFSL(SL,"channel",True) # '$channel' on line 44, col 61
            if _v is not None: write(_filter(_v, rawExpr='$channel')) # from line 44, col 61.
            write('''\');" class="link--not-skinned" title="''')
            _v = VFFSL(SL,"tstrings",True)['show_epg_for'] # "$tstrings['show_epg_for']" on line 44, col 107
            if _v is not None: write(_filter(_v, rawExpr="$tstrings['show_epg_for']")) # from line 44, col 107.
            write(''' ''')
            _v = VFFSL(SL,"channel",True) # '$channel' on line 44, col 133
            if _v is not None: write(_filter(_v, rawExpr='$channel')) # from line 44, col 133.
            write('''" data-toggle="modal" data-target="#EPGModal"><i class="icon material-icons material-icons-centered">view_list</i></button>
\t\t\t<button type="button" onclick="jumper8001(\'''')
            _v = VFFSL(SL,"sref",True) # '$sref' on line 45, col 47
            if _v is not None: write(_filter(_v, rawExpr='$sref')) # from line 45, col 47.
            write("""', '""")
            _v = VFFSL(SL,"channel",True) # '$channel' on line 45, col 56
            if _v is not None: write(_filter(_v, rawExpr='$channel')) # from line 45, col 56.
            write('''\');" class="link--not-skinned" title="''')
            _v = VFFSL(SL,"tstrings",True)['stream'] # "$tstrings['stream']" on line 45, col 102
            if _v is not None: write(_filter(_v, rawExpr="$tstrings['stream']")) # from line 45, col 102.
            write(''' ''')
            _v = VFFSL(SL,"channel",True) # '$channel' on line 45, col 122
            if _v is not None: write(_filter(_v, rawExpr='$channel')) # from line 45, col 122.
            write('''"><i class="icon material-icons material-icons-centered">ondemand_video</i></button>
''')
            if VFFSL(SL,"transcoding",True): # generated from line 46, col 4
                write('''\t\t\t<button type="button" onclick="jumper8002(\'''')
                _v = VFFSL(SL,"sref",True) # '$sref' on line 47, col 47
                if _v is not None: write(_filter(_v, rawExpr='$sref')) # from line 47, col 47.
                write("""', '""")
                _v = VFFSL(SL,"channel",True) # '$channel' on line 47, col 56
                if _v is not None: write(_filter(_v, rawExpr='$channel')) # from line 47, col 56.
                write('''\');" class="link--not-skinned" title="''')
                _v = VFFSL(SL,"tstrings",True)['stream'] # "$tstrings['stream']" on line 47, col 102
                if _v is not None: write(_filter(_v, rawExpr="$tstrings['stream']")) # from line 47, col 102.
                write(''' (''')
                _v = VFFSL(SL,"tstrings",True)['transcoded'] # "$tstrings['transcoded']" on line 47, col 123
                if _v is not None: write(_filter(_v, rawExpr="$tstrings['transcoded']")) # from line 47, col 123.
                write(''') ''')
                _v = VFFSL(SL,"channel",True) # '$channel' on line 47, col 148
                if _v is not None: write(_filter(_v, rawExpr='$channel')) # from line 47, col 148.
                write('''"><i class="icon material-icons material-icons-centered">smartphone</i></button>
''')
            #  #if $transcoding
            #  <button onclick="jumper8001('$sref', '$channel');" class="link--not-skinned" title="$tstrings['stream']: $channel">
            #  <i class="material-icons material-icons-centered">tv</i>
            #  </button>
            #  <button onclick="jumper8002('$sref', '$channel');" class="link--not-skinned" title="$tstrings['stream'] ($tstrings['transcoded']): $channel">
            #  <i class="material-icons material-icons-centered">phone_android</i>
            #  </button>
            #  #else
            #  <button class="link--not-skinned">
            #  <a href="/web/stream.m3u?ref=$sref&name=$channel" class="link--not-skinned" target="stream" title="$tstrings['stream'] $channel">
            #  <i class="material-icons material-icons-centered">ondemand_video</i>
            #  </a>
            #  </button>
            #  #end if	
        #  #end if
        write('''\t\t</div>
\t</div>
</div>

<div class="row clearfix pull-left">
\t<div class="col-xs-12">
\t\t<h4 class="event-detail__title">''')
        _v = VFFSL(SL,"event.title",True) # '$event.title' on line 71, col 35
        if _v is not None: write(_filter(_v, rawExpr='$event.title')) # from line 71, col 35.
        write('''</h4>
\t\t<h5 class="event-detail__time">''')
        _v = VFFSL(SL,"tstrings",True)[("day_" + (VFN(VFFSL(SL,"time",True),"strftime",False)("%w", VFFSL(SL,"etime",True))))] # '$tstrings[("day_" + ($time.strftime("%w", $etime)))]' on line 72, col 34
        if _v is not None: write(_filter(_v, rawExpr='$tstrings[("day_" + ($time.strftime("%w", $etime)))]')) # from line 72, col 34.
        write('''. ''')
        _v = VFN(VFFSL(SL,"time",True),"strftime",False)("%d", VFFSL(SL,"etime",True)) # '$time.strftime("%d", $etime)' on line 72, col 88
        if _v is not None: write(_filter(_v, rawExpr='$time.strftime("%d", $etime)')) # from line 72, col 88.
        write('''. ''')
        _v = VFFSL(SL,"tstrings",True)[("month_" + (VFN(VFFSL(SL,"time",True),"strftime",False)("%m", VFFSL(SL,"etime",True))))] # '$tstrings[("month_" + ($time.strftime("%m", $etime)))]' on line 72, col 118
        if _v is not None: write(_filter(_v, rawExpr='$tstrings[("month_" + ($time.strftime("%m", $etime)))]')) # from line 72, col 118.
        write(''' ''')
        _v = VFFSL(SL,"event.begin_str",True) # '$event.begin_str' on line 72, col 173
        if _v is not None: write(_filter(_v, rawExpr='$event.begin_str')) # from line 72, col 173.
        write(''' - ''')
        _v = VFFSL(SL,"event.end",True) # '$event.end' on line 72, col 192
        if _v is not None: write(_filter(_v, rawExpr='$event.end')) # from line 72, col 192.
        write('''&nbsp;&nbsp;(''')
        _v = VFFSL(SL,"int",False)(VFFSL(SL,"event.duration",True)/60) # '$int($event.duration/60)' on line 72, col 215
        if _v is not None: write(_filter(_v, rawExpr='$int($event.duration/60)')) # from line 72, col 215.
        write(''' min)</h5>
\t</div>
</div>
<div class="row clearfix">
\t<div class="col-xs-12">
''')
        if VFFSL(SL,"event.title",True) != VFFSL(SL,"event.shortdesc",True): # generated from line 77, col 1
            write('''\t\t<p class="event-detail__description">''')
            _v = VFFSL(SL,"event.shortdesc",True) # '$event.shortdesc' on line 78, col 40
            if _v is not None: write(_filter(_v, rawExpr='$event.shortdesc')) # from line 78, col 40.
            write('''</p>
''')
        write('''\t</div>
</div>
<div class="row clearfix">
\t<div class="col-xs-12 m-t-10">
\t\t<p class="event-detail__description">
\t\t\t''')
        _v = VFN(VFN(VFFSL(SL,"event.longdesc",True),"replace",False)("\n","<br/>"),"replace",False)(u"\u008a","<br/>") # '$(event.longdesc.replace("\\n","<br/>").replace(u"\\u008a","<br/>"))' on line 85, col 4
        if _v is not None: write(_filter(_v, rawExpr='$(event.longdesc.replace("\\n","<br/>").replace(u"\\u008a","<br/>"))')) # from line 85, col 4.
        write('''
\t\t</p>
\t</div>
</div>
''')
        if VFFSL(SL,"extEventInfoProvider",True): # generated from line 89, col 1
            write('''<div class="row clearfix">
\t<div class="col-xs-12 m-b-10">
\t\t<a href="''')
            _v = VFFSL(SL,"extEventInfoProvider",True)['url'] # "$extEventInfoProvider['url']" on line 92, col 12
            if _v is not None: write(_filter(_v, rawExpr="$extEventInfoProvider['url']")) # from line 92, col 12.
            _v = VFFSL(SL,"quote",False)(VFFSL(SL,"event.title",True)) # '$quote($event.title)' on line 92, col 40
            if _v is not None: write(_filter(_v, rawExpr='$quote($event.title)')) # from line 92, col 40.
            write('''" class="link--skinned" title="''')
            _v = VFFSL(SL,"tstrings",True)['search_'+VFFSL(SL,"extEventInfoProvider",True)['id']] # "$tstrings['search_'+$extEventInfoProvider['id']]" on line 92, col 91
            if _v is not None: write(_filter(_v, rawExpr="$tstrings['search_'+$extEventInfoProvider['id']]")) # from line 92, col 91.
            write('''" target="extdb">
\t\t\t<i class="material-icons material-icons-centered" style="margin-right: 0;">open_in_new</i>
\t\t\t''')
            _v = VFFSL(SL,"extEventInfoProvider",True)['name'] # "$extEventInfoProvider['name']" on line 94, col 4
            if _v is not None: write(_filter(_v, rawExpr="$extEventInfoProvider['name']")) # from line 94, col 4.
            write('''
\t\t</a>
\t</div>
</div>
''')
        write('''
<div class="row clearfix">
\t<div class="col-xs-12 event-detail__actions">

''')
        if VFFSL(SL,"event.timer",True): # generated from line 103, col 1
            if VFFSL(SL,"event.timer.isEnabled",True): # generated from line 104, col 2
                write('''\t\t<button onclick="toggleTimerStatus(\'''')
                _v = VFFSL(SL,"sref",True) # '$sref' on line 105, col 39
                if _v is not None: write(_filter(_v, rawExpr='$sref')) # from line 105, col 39.
                write("""', '""")
                _v = VFFSL(SL,"event.begin",True) # '$event.begin' on line 105, col 48
                if _v is not None: write(_filter(_v, rawExpr='$event.begin')) # from line 105, col 48.
                write("""', '""")
                _v = VFFSL(SL,"event.end",True) # '$event.end' on line 105, col 64
                if _v is not None: write(_filter(_v, rawExpr='$event.end')) # from line 105, col 64.
                write('''\');" class="link--not-skinned" title="''')
                _v = VFFSL(SL,"tstrings",True)['disable_timer'] # "$tstrings['disable_timer']" on line 105, col 112
                if _v is not None: write(_filter(_v, rawExpr="$tstrings['disable_timer']")) # from line 105, col 112.
                write('''">
\t\t\t<i class="material-icons material-icons-centered">alarm_off</i>
\t\t</button>
''')
            else: # generated from line 108, col 2
                write('''\t\t<button onclick="toggleTimerStatus(\'''')
                _v = VFFSL(SL,"sref",True) # '$sref' on line 109, col 39
                if _v is not None: write(_filter(_v, rawExpr='$sref')) # from line 109, col 39.
                write("""', '""")
                _v = VFFSL(SL,"event.begin",True) # '$event.begin' on line 109, col 48
                if _v is not None: write(_filter(_v, rawExpr='$event.begin')) # from line 109, col 48.
                write("""', '""")
                _v = VFFSL(SL,"event.end",True) # '$event.end' on line 109, col 64
                if _v is not None: write(_filter(_v, rawExpr='$event.end')) # from line 109, col 64.
                write('''\');" class="link--not-skinned" title="''')
                _v = VFFSL(SL,"tstrings",True)['enable_timer'] # "$tstrings['enable_timer']" on line 109, col 112
                if _v is not None: write(_filter(_v, rawExpr="$tstrings['enable_timer']")) # from line 109, col 112.
                write('''">
\t\t\t<i class="material-icons material-icons-centered">alarm_on</i>
\t\t</button>
''')
            write('''\t\t<button class="link--not-skinned" data-target="#TimerModal" data-toggle="modal" data-dismiss="modal" title="''')
            _v = VFFSL(SL,"tstrings",True)['edit_timer'] # "$tstrings['edit_timer']" on line 113, col 111
            if _v is not None: write(_filter(_v, rawExpr="$tstrings['edit_timer']")) # from line 113, col 111.
            write('''">
\t\t\t<i class="material-icons material-icons-centered">edit</i>
\t\t</button>
\t\t<button onclick="delTimerEvent(\'''')
            _v = VFFSL(SL,"sref",True) # '$sref' on line 116, col 35
            if _v is not None: write(_filter(_v, rawExpr='$sref')) # from line 116, col 35.
            write("""', '""")
            _v = VFFSL(SL,"event.id",True) # '$event.id' on line 116, col 44
            if _v is not None: write(_filter(_v, rawExpr='$event.id')) # from line 116, col 44.
            write('''\');" class="link--not-skinned" title="''')
            _v = VFFSL(SL,"tstrings",True)['delete_timer'] # "$tstrings['delete_timer']" on line 116, col 91
            if _v is not None: write(_filter(_v, rawExpr="$tstrings['delete_timer']")) # from line 116, col 91.
            write('''">
\t\t\t<i class="material-icons material-icons-centered">delete</i>
\t\t</button>
''')
        else: # generated from line 119, col 1
            write('''\t\t<button onclick="addTimerEvent(\'''')
            _v = VFFSL(SL,"sref",True) # '$sref' on line 120, col 35
            if _v is not None: write(_filter(_v, rawExpr='$sref')) # from line 120, col 35.
            write("""', '""")
            _v = VFFSL(SL,"event.id",True) # '$event.id' on line 120, col 44
            if _v is not None: write(_filter(_v, rawExpr='$event.id')) # from line 120, col 44.
            write('''\', false);" class="link--not-skinned" title="''')
            _v = VFFSL(SL,"tstrings",True)['add_timer'] # "$tstrings['add_timer']" on line 120, col 98
            if _v is not None: write(_filter(_v, rawExpr="$tstrings['add_timer']")) # from line 120, col 98.
            write('''">
\t\t\t<i class="material-icons material-icons-centered">alarm_add</i>
\t\t</button>
\t\t<button class="link--not-skinned" data-target="#TimerModal" data-toggle="modal" data-dismiss="modal" title="''')
            _v = VFFSL(SL,"tstrings",True)['add'] # "$tstrings['add']" on line 123, col 111
            if _v is not None: write(_filter(_v, rawExpr="$tstrings['add']")) # from line 123, col 111.
            write(''' & ''')
            _v = VFFSL(SL,"tstrings",True)['edit_timer'] # "$tstrings['edit_timer']" on line 123, col 130
            if _v is not None: write(_filter(_v, rawExpr="$tstrings['edit_timer']")) # from line 123, col 130.
            write('''">
\t\t\t<i class="material-icons material-icons-centered">alarm_add</i>
\t\t\t<i class="material-icons material-icons-centered">edit</i>
\t\t</button>
\t\t<button onclick="addTimerEvent(\'''')
            _v = VFFSL(SL,"sref",True) # '$sref' on line 127, col 35
            if _v is not None: write(_filter(_v, rawExpr='$sref')) # from line 127, col 35.
            write("""', '""")
            _v = VFFSL(SL,"event.id",True) # '$event.id' on line 127, col 44
            if _v is not None: write(_filter(_v, rawExpr='$event.id')) # from line 127, col 44.
            write('''\', true);" class="link--not-skinned" title="''')
            _v = VFFSL(SL,"tstrings",True)['add_zaptimer'] # "$tstrings['add_zaptimer']" on line 127, col 97
            if _v is not None: write(_filter(_v, rawExpr="$tstrings['add_zaptimer']")) # from line 127, col 97.
            write('''">
\t\t\t<i class="material-icons material-icons-centered">add_alert</i>
\t\t</button>
''')
        write('''
''')
        if VFFSL(SL,"at",True): # generated from line 132, col 1
            write('''\t\t<button class="link--not-skinned" onclick=\'location.href="#/at/new?name=''')
            _v = VFFSL(SL,"title",True) # '$title' on line 133, col 75
            if _v is not None: write(_filter(_v, rawExpr='$title')) # from line 133, col 75.
            write('''&match=''')
            _v = VFFSL(SL,"title",True) # '$title' on line 133, col 88
            if _v is not None: write(_filter(_v, rawExpr='$title')) # from line 133, col 88.
            write('''&timespanFrom=''')
            _v = VFFSL(SL,"event.begin_str",True) # '$event.begin_str' on line 133, col 108
            if _v is not None: write(_filter(_v, rawExpr='$event.begin_str')) # from line 133, col 108.
            write('''&timespanTo=''')
            _v = VFFSL(SL,"event.end",True) # '$event.end' on line 133, col 136
            if _v is not None: write(_filter(_v, rawExpr='$event.end')) # from line 133, col 136.
            write('''&sref=''')
            _v = VFFSL(SL,"sref",True) # '$sref' on line 133, col 152
            if _v is not None: write(_filter(_v, rawExpr='$sref')) # from line 133, col 152.
            write('''";\' class="link--not-skinned" title="''')
            _v = VFFSL(SL,"tstrings",True)['add_autotimer'] # "$tstrings['add_autotimer']" on line 133, col 194
            if _v is not None: write(_filter(_v, rawExpr="$tstrings['add_autotimer']")) # from line 133, col 194.
            write('''" data-dismiss="modal">
\t\t\t<i class="material-icons material-icons-centered">av_timer</i>
\t\t</button>
''')
        write('''\t</div>
</div>
</div>''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_genTime = __CHEETAH_genTime__

    _CHEETAH_genTimestamp = __CHEETAH_genTimestamp__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    _mainCheetahMethod_for_event = 'respond'

## END CLASS DEFINITION

if not hasattr(event, '_initCheetahAttributes'):
    templateAPIClass = getattr(event,
                               '_CHEETAH_templateClass',
                               Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(event)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit https://cheetahtemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=event()).run()


